require("Vector2");
require("tileMap");
require("player");

function love.load()
	tileMap:load();
	
	p = player:new();
	p.x = 300;
    p.y = 300;
    p.width = 32;
    p.height = 32;
    p.jumpSpeed = -800;
    p.runSpeed = 500; -- 500
    
    gravity = 2800; -- 1800
    hasJumped = false;
    delay = 120;
end

function love.update(dt)
	-- check controls
    if love.keyboard.isDown("right") then
        p:moveRight();
    end
    if love.keyboard.isDown("left") then
        p:moveLeft();
    end
    if love.keyboard.isDown("x") and not(hasJumped) then
        hasJumped = true;
        p:jump();
    end
 
    -- update the player's position and check for map collisions
    p:update(dt, gravity, tileMap.map);
end

function love.keyreleased(key)
    if key == "escape" then
        love.event.push("quit")   -- actually causes the app to quit
    end
    if (key == "right") or (key == "left") then
        p:stop()
    end
    if (key == "x") then
        hasJumped = false
    end
end

function love.draw()
	tileMap:draw();
	
	-- round our x, y values
    local x, y = math.floor(p.x), math.floor(p.y)

	-- draw the player
    love.graphics.rectangle("fill", x - p.width / 2, y - p.height / 2, p.width, p.height);
end










